diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
index 6218947b9..a246074d2 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlate.java
@@ -10,24 +10,24 @@ import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.sound.SoundCategory;
-import net.minecraft.core.util.phys.AABB;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
 
 import java.util.List;
 import java.util.Random;
 
-public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implements IPaintable, ISupportable
-{
+public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implements IPaintable, ISupportable {
     public static final int MASK_POWERED = 0b0000_0001;
     public static final int MASK_SIDE = 0b0000_1110;
     private final @NotNull Class<T> triggerMobClass;
 
-	public BlockLogicPressurePlate(@NotNull Block<?> block, @NotNull Class<T> mobType, @NotNull Material material)
-    {
+    public BlockLogicPressurePlate(@NotNull Block<?> block, @NotNull Class<T> mobType, @NotNull Material material) {
         super(block, material);
         this.triggerMobClass = mobType;
         block.setTicking(true);
@@ -36,35 +36,32 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
     }
 
     @Override
-    public int tickDelay()
-    {
+    public int tickDelay() {
         return 20;
     }
 
     @Override
-    public @Nullable AABB getCollisionAABB(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         return null;
     }
 
     @Override
-	public boolean isSolidRender()
-    {
+    public boolean isSolidRender() {
         return false;
     }
 
     @Override
-	public boolean isCubeShaped()
-    {
+    public boolean isCubeShaped() {
         return false;
     }
 
     @Override
-    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE;
     }
 
     @Override
-    public boolean canPlaceAt(@NotNull World world, @NotNull TilePos tilePos) {
+    public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
         return isSupported(world, tilePos, Side.BOTTOM)
             || isSupported(world, tilePos, Side.TOP)
             || isSupported(world, tilePos, Side.NORTH)
@@ -74,14 +71,14 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
     }
 
     @Override
-	public void onNeighborChanged(@NotNull World world, @NotNull TilePos tilePos, int id) {
-        if(!isSupported(world, tilePos, sideFromMeta(world.getBlockData(tilePos)))) {
+    public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, int id) {
+        if (!isSupported(world, tilePos, sideFromMeta(world.getBlockData(tilePos)))) {
             dropWithCause(world, EnumDropCause.WORLD, tilePos, world.getBlockData(tilePos), null, null);
             world.setBlockIdNotify(tilePos, 0);
         }
     }
 
-    private @NotNull Side getDefaultSide(@NotNull World world, @NotNull TilePos tilePos) {
+    private @NotNull Side getDefaultSide(@NotNull World world, @NotNull TilePosc tilePos) {
         for (int i = 0; i < Side.sides.length; i++) {
             Side side = Side.sides[i];
             if (isSupported(world, tilePos, side)) return side;
@@ -90,9 +87,8 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
     }
 
     @Override
-	public void updateTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand, boolean isRandomTick)
-    {
-        if(world.isClientSide) {
+    public void updateTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand, boolean isRandomTick) {
+        if (world.isClientSide) {
             return;
         }
         if (isPressed(world.getBlockData(tilePos))) {
@@ -101,8 +97,8 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
     }
 
     @Override
-    public void onEntityCollision(@NotNull World world, @NotNull TilePos tilePos, @NotNull Entity entity) {
-        if(world.isClientSide) {
+    public void onEntityCollision(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Entity entity) {
+        if (world.isClientSide) {
             return;
         }
         if (!isPressed(world.getBlockData(tilePos))) {
@@ -110,20 +106,25 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
         }
     }
 
-    private void updateState(@NotNull World world, @NotNull TilePos tilePos)
-    {
+    private void updateState(@NotNull World world, @NotNull TilePosc tilePos) {
         int meta = world.getBlockData(tilePos);
         boolean isPressed = isPressed(meta);
         Direction dir = sideFromMeta(meta).getDirection();
         boolean isSteppedOn = false;
         float pixel = 0.125F;
         List<T> list = switch (sideFromMeta(meta)) {
-            case BOTTOM -> world.getEntitiesWithinAABB(this.triggerMobClass, AABB.fromPool(pixel, 0.0F, pixel, 1.0F - pixel, (isPressed ? pixel / 2f : pixel), 1.0F - pixel).move(tilePos));
-            case TOP -> world.getEntitiesWithinAABB(this.triggerMobClass, AABB.fromPool(pixel, 1f - (isPressed ? pixel / 2f : pixel), pixel, 1.0F - pixel, 1f, 1.0F - pixel).move(tilePos));
-            case NORTH -> world.getEntitiesWithinAABB(this.triggerMobClass, AABB.fromPool(pixel, pixel, 0, 1 - pixel, 1 - pixel, (isPressed ? pixel / 2f : pixel)).move(tilePos));
-            case SOUTH -> world.getEntitiesWithinAABB(this.triggerMobClass, AABB.fromPool(pixel, pixel, 1f - (isPressed ? pixel / 2f : pixel), 1 - pixel, 1 - pixel, 1).move(tilePos));
-            case WEST -> world.getEntitiesWithinAABB(this.triggerMobClass, AABB.fromPool(0, pixel, pixel, (isPressed ? pixel / 2f : pixel), 1 - pixel, 1 - pixel).move(tilePos));
-            default -> world.getEntitiesWithinAABB(this.triggerMobClass, AABB.fromPool(1 - (isPressed ? pixel / 2f : pixel), pixel, pixel, 1, 1 - pixel, 1 - pixel).move(tilePos));
+            case BOTTOM ->
+                world.getEntitiesWithinAABB(this.triggerMobClass, new AABBd(pixel, 0.0F, pixel, 1.0F - pixel, (isPressed ? pixel / 2f : pixel), 1.0F - pixel).translate(tilePos.x(), tilePos.y(), tilePos.z()));
+            case TOP ->
+                world.getEntitiesWithinAABB(this.triggerMobClass, new AABBd(pixel, 1f - (isPressed ? pixel / 2f : pixel), pixel, 1.0F - pixel, 1f, 1.0F - pixel).translate(tilePos.x(), tilePos.y(), tilePos.z()));
+            case NORTH ->
+                world.getEntitiesWithinAABB(this.triggerMobClass, new AABBd(pixel, pixel, 0, 1 - pixel, 1 - pixel, (isPressed ? pixel / 2f : pixel)).translate(tilePos.x(), tilePos.y(), tilePos.z()));
+            case SOUTH ->
+                world.getEntitiesWithinAABB(this.triggerMobClass, new AABBd(pixel, pixel, 1f - (isPressed ? pixel / 2f : pixel), 1 - pixel, 1 - pixel, 1).translate(tilePos.x(), tilePos.y(), tilePos.z()));
+            case WEST ->
+                world.getEntitiesWithinAABB(this.triggerMobClass, new AABBd(0, pixel, pixel, (isPressed ? pixel / 2f : pixel), 1 - pixel, 1 - pixel).translate(tilePos.x(), tilePos.y(), tilePos.z()));
+            default ->
+                world.getEntitiesWithinAABB(this.triggerMobClass, new AABBd(1 - (isPressed ? pixel / 2f : pixel), pixel, pixel, 1, 1 - pixel, 1 - pixel).translate(tilePos.x(), tilePos.y(), tilePos.z()));
         };
 
         for (T t : list) {
@@ -132,67 +133,65 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
                 break;
             }
         }
-        if(isSteppedOn && !isPressed) {
+        if (isSteppedOn && !isPressed) {
             world.setBlockDataNotify(tilePos, meta | MASK_POWERED);
             world.notifyBlocksOfNeighborChange(tilePos, id());
-            world.notifyBlocksOfNeighborChange(tilePos.add(dir), id());
+            world.notifyBlocksOfNeighborChange(tilePos.add(dir, new TilePos()), id());
             world.markBlocksDirty(tilePos, tilePos);
-            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)tilePos.x + 0.5D, (double)tilePos.y + 0.1D, (double)tilePos.z + 0.5D, "random.click", 0.3F, 0.6F);
-        } else if(!isSteppedOn && isPressed) {
+            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.1D, (double) tilePos.z() + 0.5D, "random.click", 0.3F, 0.6F);
+        } else if (!isSteppedOn && isPressed) {
             world.setBlockDataNotify(tilePos, meta & ~MASK_POWERED);
             world.notifyBlocksOfNeighborChange(tilePos, id());
-            world.notifyBlocksOfNeighborChange(tilePos.add(dir), id());
+            world.notifyBlocksOfNeighborChange(tilePos.add(dir, new TilePos()), id());
             world.markBlocksDirty(tilePos, tilePos);
-            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double)tilePos.x + 0.5D, (double)tilePos.y + 0.1D, (double)tilePos.z + 0.5D, "random.click", 0.3F, 0.5F);
+            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, (double) tilePos.x() + 0.5D, (double) tilePos.y() + 0.1D, (double) tilePos.z() + 0.5D, "random.click", 0.3F, 0.5F);
         }
-        if(isSteppedOn)
-        {
+        if (isSteppedOn) {
             world.scheduleBlockUpdate(tilePos, id(), tickDelay());
         }
     }
 
     @Override
-    public void onRemoved(@NotNull World world, @NotNull TilePos tilePos, int data)
-    {
-        if(isPressed(data)) {
+    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
+        if (isPressed(data)) {
             Side side = sideFromMeta(world.getBlockData(tilePos));
             world.notifyBlocksOfNeighborChange(tilePos, id());
-            world.notifyBlocksOfNeighborChange(tilePos.add(side.getDirection()), id());
+            world.notifyBlocksOfNeighborChange(tilePos.add(side.getDirection(), new TilePos()), id());
         }
         super.onRemoved(world, tilePos, data);
     }
 
     @Override
-    public @NotNull AABB getBoundsFromState(@NotNull WorldSource source, @NotNull TilePos tilePos) {
+    public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         int meta = source.getBlockData(tilePos);
         boolean isPressed = isPressed(meta);
         final float pixel = 1.0f / 16f;
         return switch (sideFromMeta(meta)) {
-            case BOTTOM -> AABB.fromPool(pixel, 0.0F, pixel, 1.0F - pixel, (isPressed ? pixel / 2f : pixel), 1.0F - pixel);
-            case TOP -> AABB.fromPool(pixel, 1f - (isPressed ? pixel / 2f : pixel), pixel, 1.0F - pixel, 1f, 1.0F - pixel);
-            case NORTH -> AABB.fromPool(pixel, pixel, 0, 1 - pixel, 1 - pixel, (isPressed ? pixel / 2f : pixel));
-            case SOUTH -> AABB.fromPool(pixel, pixel, 1f - (isPressed ? pixel / 2f : pixel), 1 - pixel, 1 - pixel, 1);
-            case WEST -> AABB.fromPool(0, pixel, pixel, (isPressed ? pixel / 2f : pixel), 1 - pixel, 1 - pixel);
-            default -> AABB.fromPool(1 - (isPressed ? pixel / 2f : pixel), pixel, pixel, 1, 1 - pixel, 1 - pixel);
+            case BOTTOM -> new AABBd(pixel, 0.0F, pixel, 1.0F - pixel, (isPressed ? pixel / 2f : pixel), 1.0F - pixel);
+            case TOP -> new AABBd(pixel, 1f - (isPressed ? pixel / 2f : pixel), pixel, 1.0F - pixel, 1f, 1.0F - pixel);
+            case NORTH -> new AABBd(pixel, pixel, 0, 1 - pixel, 1 - pixel, (isPressed ? pixel / 2f : pixel));
+            case SOUTH -> new AABBd(pixel, pixel, 1f - (isPressed ? pixel / 2f : pixel), 1 - pixel, 1 - pixel, 1);
+            case WEST -> new AABBd(0, pixel, pixel, (isPressed ? pixel / 2f : pixel), 1 - pixel, 1 - pixel);
+            default -> new AABBd(1 - (isPressed ? pixel / 2f : pixel), pixel, pixel, 1, 1 - pixel, 1 - pixel);
         };
     }
 
     @Override
-    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePos tilePos, @NotNull Side side) {
+    public boolean isEmittingSignal(@NotNull WorldSource source, @NotNull TilePosc tilePos, @NotNull Side side) {
         return isPressed(source.getBlockData(tilePos));
     }
 
     @Override
-    public boolean isEmittingDirectSignal(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public boolean isEmittingDirectSignal(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         int meta = world.getBlockData(tilePos);
-        if(isPressed(meta)) {
+        if (isPressed(meta)) {
             return side == sideFromMeta(meta).getOpposite();
         } else {
             return false;
         }
     }
 
-    public static boolean isPressed(int meta){
+    public static boolean isPressed(int meta) {
         return (meta & MASK_POWERED) != 0;
     }
 
@@ -205,17 +204,17 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
     }
 
     @Override
-    public boolean isSignalSource()
-    {
+    public boolean isSignalSource() {
         return true;
     }
 
     @Override
-    public int getPistonPushReaction(@NotNull World world, @NotNull TilePos tilePos) {
+    public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
         return Material.PISTON_DESTROY_ON_PUSH;
     }
+
     @Override
-    public void onPlacedOnSide(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public void onPlacedOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         int meta = world.getBlockData(tilePos);
         side = side.getOpposite();
         if (!isSupported(world, tilePos, side)) {
@@ -236,7 +235,7 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
     }
 
     @Override
-    public void setColor(@NotNull World world, @NotNull TilePos tilePos, @NotNull DyeColor color) {
+    public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
         final int meta = world.getBlockData(tilePos);
         world.setBlockIdDataRaw(tilePos, Blocks.PRESSURE_PLATE_PLANKS_OAK_PAINTED.id(), meta);
         world.setBlockData(tilePos, meta);
@@ -247,7 +246,7 @@ public class BlockLogicPressurePlate<T extends Entity> extends BlockLogic implem
     }
 
     @Override
-    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePos tilePos, @NotNull Side side) {
+    public @NotNull ISupport getSupportConstraint(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return PartialSupport.INSTANCE.center();
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlatePainted.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlatePainted.java
index 0e674a745..be23d76c8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlatePainted.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPressurePlatePainted.java
@@ -9,7 +9,7 @@ import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.util.helper.DyeColor;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -45,17 +45,17 @@ public class BlockLogicPressurePlatePainted<T extends Entity> extends BlockLogic
     }
 
     @Override
-    public void removeDye(@NotNull World world, @NotNull TilePos tilePos) {
+    public void removeDye(@NotNull World world, @NotNull TilePosc tilePos) {
         world.setBlockIdNotify(tilePos, Blocks.PRESSURE_PLATE_PLANKS_OAK.id());
     }
 
     @Override
-    public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePos tilePos, @NotNull Side side, double xHit, double yHit) {
+    public int getPlacedData(@Nullable Player player, @NotNull ItemStack itemStack, @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, double xHit, double yHit) {
         return itemStack.getMetadata() & MASK_COLOR;
     }
 
     @Override
-    public void setColor(@NotNull World world, @NotNull TilePos tilePos, @NotNull DyeColor color) {
+    public void setColor(@NotNull World world, @NotNull TilePosc tilePos, @NotNull DyeColor color) {
         final int meta = world.getBlockData(tilePos);
         world.setBlockDataNotify(tilePos, stripColorFromMetadata(meta) | toMetadata(color));
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java
index 6ea2356c6..4469a97e8 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumice.java
@@ -1,47 +1,43 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.material.Material;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.tag.BlockTags;
 import net.minecraft.core.sound.SoundCategory;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.world.Dimension;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 
 import java.util.Random;
 
 public class BlockLogicPumice extends BlockLogic {
     final boolean isWet;
-    public BlockLogicPumice(@NotNull Block<?> block, boolean isWet)
-    {
-        super(block, Material.stone);
+
+    public BlockLogicPumice(@NotNull Block<?> block, boolean isWet) {
+        super(block, Materials.STONE);
         this.isWet = isWet;
     }
 
     @Override
-    public void onPlacedByWorld(@NotNull World world, @NotNull TilePos tilePos)
-    {
+    public void onPlacedByWorld(@NotNull World world, @NotNull TilePosc tilePos) {
         super.onPlacedByWorld(world, tilePos);
         byte radius = 2;
-        if(this.isWet && (inWater(world, tilePos) || world.dimension.id == Dimension.DRIFT.id)){
+        if (this.isWet && (inWater(world, tilePos) || world.dimension.id == Dimension.DRIFT.id)) {
             world.setBlockIdNotify(tilePos, Blocks.PUMICE_DRY.id());
-            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x + 0.5D, tilePos.y + 0.5D, tilePos.z + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
-            for(int l = 0; l < 8; l++)
-            {
-                world.spawnParticle("largesmoke", (double)tilePos.x + Math.random(), (double)tilePos.y + Math.random(), (double)tilePos.z + Math.random(), 0.0D, 0.0D, 0.0D, 0);
+            world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5D, tilePos.y() + 0.5D, tilePos.z() + 0.5D, "random.fizz", 0.5F, 2.6F + (world.rand.nextFloat() - world.rand.nextFloat()) * 0.8F);
+            for (int l = 0; l < 8; l++) {
+                world.spawnParticle("largesmoke", (double) tilePos.x() + Math.random(), (double) tilePos.y() + Math.random(), (double) tilePos.z() + Math.random(), 0.0D, 0.0D, 0.0D, 0);
             }
         }
-        if(!this.isWet && inLava(world, tilePos)) {
-            TilePos p = new TilePos(tilePos);
-            for (int x = tilePos.x - radius; x <= tilePos.x + radius; x++) {
-                for (int y = tilePos.y - radius; y <= tilePos.y + radius; y++) {
-                    for (int z = tilePos.z - radius; z <= tilePos.z + radius; z++) {
-                        p.x = x;
-                        p.y = y;
-                        p.z = z;
-                        if (Blocks.hasTag(world.getBlockId(p), BlockTags.IS_LAVA)) {
-                            world.setBlockIdNotify(p, 0);
+        if (!this.isWet && inLava(world, tilePos)) {
+            TilePos queryPos = new TilePos(tilePos);
+            for (queryPos.x = tilePos.x() - radius; queryPos.x <= tilePos.x() + radius; queryPos.x++) {
+                for (queryPos.y = tilePos.y() - radius; queryPos.y <= tilePos.y() + radius; queryPos.y++) {
+                    for (queryPos.z = tilePos.z() - radius; queryPos.z <= tilePos.z() + radius; queryPos.z++) {
+                        if (Blocks.hasTag(world.getBlockId(queryPos), BlockTags.IS_LAVA)) {
+                            world.setBlockIdNotify(queryPos, 0);
                         }
                     }
                 }
@@ -51,38 +47,37 @@ public class BlockLogicPumice extends BlockLogic {
     }
 
 
-    public boolean inLava(@NotNull World world, @NotNull TilePos tilePos){
+    public boolean inLava(@NotNull World world, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
         return
-            Blocks.hasTag(world.getBlockId(tilePos.east()), BlockTags.IS_LAVA) ||
-            Blocks.hasTag(world.getBlockId(tilePos.west()), BlockTags.IS_LAVA) ||
-            Blocks.hasTag(world.getBlockId(tilePos.up()), BlockTags.IS_LAVA) ||
-            Blocks.hasTag(world.getBlockId(tilePos.down()), BlockTags.IS_LAVA) ||
-            Blocks.hasTag(world.getBlockId(tilePos.south()), BlockTags.IS_LAVA) ||
-            Blocks.hasTag(world.getBlockId(tilePos.north()), BlockTags.IS_LAVA);
+            Blocks.hasTag(world.getBlockId(tilePos.east(queryPos)), BlockTags.IS_LAVA) ||
+                Blocks.hasTag(world.getBlockId(tilePos.west(queryPos)), BlockTags.IS_LAVA) ||
+                Blocks.hasTag(world.getBlockId(tilePos.up(queryPos)), BlockTags.IS_LAVA) ||
+                Blocks.hasTag(world.getBlockId(tilePos.down(queryPos)), BlockTags.IS_LAVA) ||
+                Blocks.hasTag(world.getBlockId(tilePos.south(queryPos)), BlockTags.IS_LAVA) ||
+                Blocks.hasTag(world.getBlockId(tilePos.north(queryPos)), BlockTags.IS_LAVA);
     }
 
-    public boolean inWater(@NotNull World world, @NotNull TilePos tilePos){
+    public boolean inWater(@NotNull World world, @NotNull TilePosc tilePos) {
+        TilePos queryPos = new TilePos();
         return
-            Blocks.hasTag(world.getBlockId(tilePos.east()), BlockTags.IS_WATER) ||
-            Blocks.hasTag(world.getBlockId(tilePos.west()), BlockTags.IS_WATER) ||
-            Blocks.hasTag(world.getBlockId(tilePos.up()), BlockTags.IS_WATER) ||
-            Blocks.hasTag(world.getBlockId(tilePos.down()), BlockTags.IS_WATER) ||
-            Blocks.hasTag(world.getBlockId(tilePos.south()), BlockTags.IS_WATER) ||
-            Blocks.hasTag(world.getBlockId(tilePos.north()), BlockTags.IS_WATER);
+            Blocks.hasTag(world.getBlockId(tilePos.east(queryPos)), BlockTags.IS_WATER) ||
+                Blocks.hasTag(world.getBlockId(tilePos.west(queryPos)), BlockTags.IS_WATER) ||
+                Blocks.hasTag(world.getBlockId(tilePos.up(queryPos)), BlockTags.IS_WATER) ||
+                Blocks.hasTag(world.getBlockId(tilePos.down(queryPos)), BlockTags.IS_WATER) ||
+                Blocks.hasTag(world.getBlockId(tilePos.south(queryPos)), BlockTags.IS_WATER) ||
+                Blocks.hasTag(world.getBlockId(tilePos.north(queryPos)), BlockTags.IS_WATER);
     }
 
     @Override
-    public void onRemoved(@NotNull World world, @NotNull TilePos tilePos, int data) {
-        if(!this.isWet) {
+    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
+        if (!this.isWet) {
             byte radius = 2;
-            TilePos p = new TilePos(tilePos);
-            for (int x = tilePos.x - radius; x <= tilePos.x + radius; x++) {
-                for (int y = tilePos.y - radius; y <= tilePos.y + radius; y++) {
-                    for (int z = tilePos.z - radius; z <= tilePos.z + radius; z++) {
-                        p.x = x;
-                        p.y = y;
-                        p.z = z;
-                        world.notifyBlocksOfNeighborChange(p, world.getBlockId(p));
+            TilePos queryPos = new TilePos(tilePos);
+            for (queryPos.x = tilePos.x() - radius; queryPos.x <= tilePos.x() + radius; queryPos.x++) {
+                for (queryPos.y = tilePos.y() - radius; queryPos.y <= tilePos.y() + radius; queryPos.y++) {
+                    for (queryPos.z = tilePos.z() - radius; queryPos.z <= tilePos.z() + radius; queryPos.z++) {
+                        world.notifyBlocksOfNeighborChange(queryPos, world.getBlockId(queryPos));
                     }
 
                 }
@@ -92,27 +87,27 @@ public class BlockLogicPumice extends BlockLogic {
     }
 
     @Override
-    public void animationTick(@NotNull World world, @NotNull TilePos tilePos, @NotNull Random rand) {
+    public void animationTick(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Random rand) {
         if (this.isWet) {
             Direction direction = Direction.directions[rand.nextInt(6)]; // Get random side
-            if (direction == Direction.UP || world.isBlockOpaqueCube(tilePos.add(direction))) return;
+            if (direction == Direction.UP || world.isBlockOpaqueCube(tilePos.add(direction, new TilePos()))) return;
             float off1 = rand.nextFloat() * 0.9f + 0.05f;
             float off2 = rand.nextFloat() * 0.9f + 0.05f;
             switch (direction) {
                 case DOWN:
-                    world.spawnParticle("dripLava", tilePos.x + off1, tilePos.y, tilePos.z + off2, 0, 0, 0, 0);
+                    world.spawnParticle("dripLava", tilePos.x() + off1, tilePos.y(), tilePos.z() + off2, 0, 0, 0, 0);
                     break;
                 case NORTH:
-                    world.spawnParticle("dripLava", tilePos.x + off1, tilePos.y + off2, tilePos.z, 0, 0, 0, 0);
+                    world.spawnParticle("dripLava", tilePos.x() + off1, tilePos.y() + off2, tilePos.z(), 0, 0, 0, 0);
                     break;
                 case SOUTH:
-                    world.spawnParticle("dripLava", tilePos.x + off1, tilePos.y + off2, tilePos.z + 1, 0, 0, 0, 0);
+                    world.spawnParticle("dripLava", tilePos.x() + off1, tilePos.y() + off2, tilePos.z() + 1, 0, 0, 0, 0);
                     break;
                 case WEST:
-                    world.spawnParticle("dripLava", tilePos.x, tilePos.y + off1, tilePos.z + off2, 0, 0, 0, 0);
+                    world.spawnParticle("dripLava", tilePos.x(), tilePos.y() + off1, tilePos.z() + off2, 0, 0, 0, 0);
                     break;
                 case EAST:
-                    world.spawnParticle("dripLava", tilePos.x + 1, tilePos.y + off1, tilePos.z + off2, 0, 0, 0, 0);
+                    world.spawnParticle("dripLava", tilePos.x() + 1, tilePos.y() + off1, tilePos.z() + off2, 0, 0, 0, 0);
                     break;
             }
         }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkin.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkin.java
index c1fd40fef..ec8d659db 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkin.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicPumpkin.java
@@ -1,14 +1,14 @@
 package net.minecraft.core.block;
 
-import net.minecraft.core.block.material.Material;
 import net.minecraft.core.block.material.MaterialColor;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.tool.ItemToolSword;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.pos.TilePos;
+import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 
@@ -18,14 +18,14 @@ public class BlockLogicPumpkin extends BlockLogicVeryRotatable
 
 	public BlockLogicPumpkin(@NotNull Block<?> block, boolean isCarvable)
     {
-        super(block, Material.vegetable);
+        super(block, Materials.VEGETABLE);
         block.setTicking(true);
         this.isCarvable = isCarvable;
         block.withOverrideColor(MaterialColor.paintedOrange);
     }
 
     @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePos tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
+    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
         if (!this.isCarvable) return false;
         ItemStack heldItem = player.getHeldItem();
         if (heldItem != null && heldItem.getItem() instanceof ItemToolSword){
